package primi;
import java.util.*;
public class CrivelloBitSet extends AbstractPrimi{
    BitSet primi;

    public CrivelloBitSet(long n){
    	super(n);
    	this.primi = new BitSet((int) n);
    }
    
    public int go(){
		primi.set(2, (int) n);
		int i = 1;
		while (i * i < n) {
			i = primi.nextSetBit(i + 1);
			for (int k = i * i; k < n; k += i)
				primi.clear(k);
		}
		return primi.cardinality();
	}
}