package primi;
public class CrivelloPrimeSet5 extends AbstractPrimi{
    PrimeSet5 primi;

    public CrivelloPrimeSet5(long n){
    	super(n);
    	this.primi = new PrimeSet5(n);
    }
    
    public int go(){
		primi.set(2, n);
		long i = 5;
		while (i * i < n) {
			i = primi.nextSetBit(i + 1);
			for (long k = i * i; k < n; k += i)
				primi.clear(k);
		}
		return primi.cardinality();
	}
}