package sort;
public class QuickSort extends AbstractSort {

	public void go() {
		quickSort(0, n - 1);
	}

	private void quickSort(int l, int r) {
		if (r <= l) return;
		int i = l, j = r;
		int pivot = (int)(l+(r-l-1)*Math.random());
//		int pivot = (l + r) / 2;
		int x = A[pivot];
		do {
			while (x > A[i])
				i++;
			while (A[j] > x)
				j--;
			if (i <= j) {
				swap(i,j);
				i++;
				j--;
			}
		} while (i < j);
		if (l < j) quickSort(l, j);
		if (i < r) quickSort(i, r);
	}

}
